function Results = HDCM(y,X,EstimOpt,EstimVar)

save tmp1
% return

k1 = EstimOpt.NVARf;
N = EstimOpt.NP;
J = EstimOpt.NS;
taub = EstimOpt.tauf;
vb = EstimOpt.vf;
r1 = EstimOpt.r1;
r2 = EstimOpt.r2;
options = EstimOpt.options;
R = EstimOpt.R;

mub0 = EstimVar.b0f;
Vb0 = EstimVar.vb0f;
betadraw = EstimVar.betadraw;

betamat = zeros(k1+EstimOpt.NPAR,r2);

betacount = 0;
gcountmat = zeros(R,1);

% Xf = X(:,1:k1);
Xf = X(:,1:k1,:);
% Xfi_sliced = reshape(Xf',k1,J,N); % k1 x J x N
Xfi_sliced = zeros(k1,J,N,size(X,3));
for i=1:size(X,3)
    Xfi_sliced(:,:,:,i) = reshape(Xf(:,:,i)',[k1,J,N]); % k1 x J x N
end

% switch lower(EstimOpt.NB)
%
%     case 0 % LL function for Poisson:
%
%         LLfun = @(B) -sum(Xf*B.*y - gammaln(y+1) - exp(Xf*B));
%         mle_fun_b = @(B) mle_nb_0_f(B,Xf,y,mub0,Vb0);
%
%     case 1 % LL function for NB-2: (theta enters exponentially)
%
%         LLfun = @(B) ...
%             -sum(gammaln(exp(B(end))+y) - gammaln(exp(B(end))) - gammaln(1+y) + ...
%             y .* (Xf*B(1:end-1) - log(exp(Xf*B(1:end-1)) + exp(B(end))) ) + ...
%             exp(B(end)) .* (B(end) - log(exp(Xf*B(1:end-1)) + exp(B(end)))));
%
%         mle_fun_b = @(B) mle_nb_1_f(B,Xf,y,mub0,Vb0);
%
%     case 2 % LL function for NB-P: (theta enters exponentially)
%
%         LLfun = @(B) -sum(log((exp(B(end-1)).*exp(Xf*B(1:end-2))./(exp(B(end-1)).*exp(Xf*B(1:end-2))+exp(Xf*B(1:end-2)).^B(end))).^(exp(B(end-1)).*...
%             exp(Xf*B(1:end-2)).^(2-B(end))).*(exp(Xf*B(1:end-2)).^B(end)./(exp(B(end-1)).*exp(Xf*B(1:end-2))+exp(Xf*B(1:end-2)).^B(end))).^y./...
%             gamma(exp(B(end-1)).*exp(Xf*B(1:end-2)).^(2-B(end)))./gamma(1+y).*gamma(exp(B(end-1)).*exp(Xf*B(1:end-2)).^(2-B(end))+y)) );
%         LLfun = @(B) -sum(gammaln(exp(B(end-1)).*exp(Xf*B(1:end-2)).^(2-B(end))+y) - gammaln(exp(B(end-1)).*exp(Xf*B(1:end-2)).^(2-B(end))) - gammaln(1+y) + ...
%             (exp(B(end-1)).*exp(Xf*B(1:end-2)).^(2-B(end))).*(B(end-1) + Xf*B(1:end-2) - log(exp(B(end-1)+Xf*B(1:end-2)) + exp(Xf*B(1:end-2).*B(end)))) + ...
%             y.*(Xf*B(1:end-2).*B(end) - log(exp(B(end-1) + Xf*B(1:end-2)) + exp(Xf*B(1:end-2).*B(end) ))) );
%
%         mle_fun_b = @(B) mle_nb_P_f(B,Xf,y,mub0,Vb0);
%
%     case 3 % LL function for NB with truncation and endogenous stratification: (theta enters exponentially)
%
%         %     expand log -> replace gamma with gammaln to avoid exploding:
%         %     LLfun = @(b0) -sum( ...
%         %     log(y) + gammaln(1./exp(b0(end)) + y) + (b0(end)).*y + (Xf*b0(1:end-1)).*(y-1) + ...
%         %     log(1 + exp(b0(end)).*exp(Xf*b0(1:end-1))).*(-1./exp(b0(end))-y) - ...
%         %     gammaln(y+1) - gammaln(exp(b0(end)).^(-1))    );
%
%         %     mle_fun_b = @(B) mle_nbES_f2(B,Xf,y,mub0,Vb0);
% end

if EstimOpt.MH == 0
    
    Vc = EstimVar.Vc;
    
    disp ('==============================================================================================')
    disp ('    Iteration      Burn-in         Keep        Total     Progress     Acc.(Bf)     LLfun')
    %     disp([1 EstimOpt.r1 EstimOpt.r2 EstimOpt.R 1/EstimOpt.R betacount/1 LLfun(betadraw)]);
    disp([1 EstimOpt.r1 EstimOpt.r2 EstimOpt.R 1/EstimOpt.R betacount/1 LL_wrapper(betadraw,y,mean(Xf,3),EstimOpt)]);
    
    for r = 1:R
        
        if rem(r,EstimOpt.disp) == 0
            %             disp([r EstimOpt.r1 EstimOpt.r2 EstimOpt.R r/EstimOpt.R betacount/r betadraw' LLfun(betadraw)]);
            disp([r EstimOpt.r1 EstimOpt.r2 EstimOpt.R r/EstimOpt.R betacount/r LL_wrapper(betadraw,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt)]);
        end
        
        %         draw candidate beta
        betacan = mvnrnd(betadraw,EstimOpt.tauc*Vc)';
        
        %         acceptance rule
        if log(rand) < (log(mvnpdf(betacan,mub0,Vb0)) - LL_wrapper(betacan,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt)) - (log(mvnpdf(betadraw,mub0,Vb0)) - LL_wrapper(betadraw,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt))
            betadraw = betacan;
            betacount = betacount +1;
        end
        
        %         keep results
        if r > r1 && rem(r-r1,EstimOpt.nskip) == 0
            betamat(:,(r-r1)/EstimOpt.nskip) = betadraw;
        end
        
    end;
    
elseif EstimOpt.MH == 1 % MH with independance chain
    
    % start main loop
    disp ('==============================================================================================')
    disp ('    Iteration      Burn-in         Keep        Total     Progress     Acc.(Bf)     LLfun')
    %     disp([1 EstimOpt.r1 EstimOpt.r2 EstimOpt.R 1/EstimOpt.R betacount/1 LLfun(betadraw)]);
    disp([1 EstimOpt.r1 EstimOpt.r2 EstimOpt.R 1/EstimOpt.R betacount/1 LL_wrapper(betadraw,y,mean(Xf,3),EstimOpt)]);
    
    for r = 1:R
        
        if rem(r,EstimOpt.disp) == 0
            %             disp([r EstimOpt.r1 EstimOpt.r2 EstimOpt.R r/EstimOpt.R betacount/r betadraw' LLfun(betadraw)]);
            %             disp([r EstimOpt.r1 EstimOpt.r2 EstimOpt.R r/EstimOpt.R betacount/r LLfun(betadraw)]);
            disp([r EstimOpt.r1 EstimOpt.r2 EstimOpt.R r/EstimOpt.R betacount/r LL_wrapper(betadraw,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt)]);
        end
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % draw gi's
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        gcount = 0;
        
        gcountmat(r) = gcount/N; %take mean over all panels
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % draw beta
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        % MLE routine to get mean and VCOV for proposal function
        %         [x,~,~,~,~,H] = fminunc(mle_fun_b, betadraw, options);
        [x,~,~,~,~,H] = fminunc(@(b) LL_wrapper(b,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt,mub0,Vb0), betadraw, options);
        
        if EstimOpt.NB > 0
            H = H + inv(Vb0);
        end
        
        tvcov = taub .* inv(H);
        
        [Rho,stdV] = corrcov(tvcov);
        betacan = (x' + mvtrnd(Rho,vb) * diag(stdV))';
        
        if log(rand) < ...
                log(mvnpdf(betacan,mub0,Vb0)) - LL_wrapper(betacan,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt) - log(mvtpdf_klaus(betacan,x,tvcov,vb)) - ...
                (log(mvnpdf(betadraw,mub0,Vb0)) - LL_wrapper(betadraw,y,Xf(:,:,min(r,size(Xf,3))),EstimOpt) - log(mvtpdf_klaus(betadraw,x,tvcov,vb)))
            
            betadraw = betacan;
            betacount = betacount +1;
        end
        
        
        if r > r1
            betamat(:,r-r1) = betadraw;
        end
        
    end; %end main loop
    
else
    error ('Specify a sampler')
end

save tmp2


Results.acceptmat = [betacount/R; mean(gcountmat)];

Results.betamat = betamat;
% Results.gmat = gmat;
% Results.gimat = gimat;
% Results.Emat = Emat;

% Results.allmat = [Results.betamat;Results.gmat;Results.Emat];
% Results.kdiag = klausdiagnostics_greater0(Results.allmat);
Results.kdiag = klausdiagnostics_greater0(Results.betamat);

Results.LL = -LL_wrapper(Results.kdiag(:,1),y,mean(Xf,3),EstimOpt);
Results.R = [Results.LL,0,0; Results.kdiag(:,1:2) pv(Results.kdiag(:,1:2))];